"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.handler = exports.executeMarkCLISessionInactive = exports.executeMarkCLISessionActiveHeartbeat = exports.executeCreateNewSchemaMutation = exports.executeUpsertAppForSiteMutation = exports.fetchAppSchemaQuery = exports.executeAckCLISessionEventMutation = exports.fetchCLISessionQuery = exports.executeCreateCLISessionEventMutation = exports.executeUpdateCLISessionMetadataMutation = exports.executeCreateCLISessionMutation = exports.fetchPersistedQueryQuery = exports.fetchListPersistedQueries = exports.executeCreateApiTokenMutation = exports.executeCreatePersistedQueryMutation = exports.executeCreateGraphQLSchemaMutation = exports.verifyRequestSignature = void 0;
// GENERATED VIA NETLIFY AUTOMATED DEV TOOLS, EDIT WITH CAUTION!
var fetch = require('node-fetch');
var internalConsole = require("./internalConsole").internalConsole;
var netlifyGraphHost = process.env.NETLIFY_GRAPH_HOST || "serve.onegraph.com";
var httpFetch = function (siteId, options) { return __awaiter(void 0, void 0, void 0, function () {
    var reqBody, userHeaders, headers, timeoutMs, reqOptions, url, resp;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                reqBody = options.body || null;
                userHeaders = options.headers || {};
                headers = __assign(__assign({}, userHeaders), { "Content-Type": "application/json", "Content-Length": reqBody.length });
                timeoutMs = 30000;
                reqOptions = {
                    method: "POST",
                    headers: headers,
                    timeout: timeoutMs,
                    body: reqBody
                };
                url = "https://" + netlifyGraphHost + "/graphql?app_id=" + siteId;
                return [4 /*yield*/, fetch(url, reqOptions)];
            case 1:
                resp = _a.sent();
                return [2 /*return*/, resp.text()];
        }
    });
}); };
var fetchNetlifyGraph = function fetchNetlifyGraph(input) {
    return __awaiter(this, void 0, void 0, function () {
        var query, docId, operationName, variables, options, accessToken, siteId, payload, response;
        return __generator(this, function (_a) {
            query = input.query;
            docId = input.doc_id;
            operationName = input.operationName;
            variables = input.variables;
            options = input.options || {};
            accessToken = options.accessToken;
            siteId = options.siteId || process.env.SITE_ID;
            payload = {
                query: query,
                doc_id: docId,
                variables: variables,
                operationName: operationName,
            };
            response = httpFetch(siteId, {
                method: "POST",
                headers: {
                    Authorization: accessToken ? "Bearer " + accessToken : "",
                },
                body: JSON.stringify(payload),
            });
            return [2 /*return*/, response.then(function (result) { return JSON.parse(result); })];
        });
    });
};
var verifyRequestSignature = function (request, options) {
    var event = request.event;
    var secret = options.webhookSecret || process.env.NETLIFY_GRAPH_WEBHOOK_SECRET;
    var signature = event.headers["x-netlify-graph-signature"];
    var body = event.body;
    if (!secret) {
        console.error("NETLIFY_GRAPH_WEBHOOK_SECRET is not set, cannot verify incoming webhook request");
        return false;
    }
    return verifySignature({ secret: secret, signature: signature, body: body || "" });
};
exports.verifyRequestSignature = verifyRequestSignature;
var executeCreateGraphQLSchemaMutation = function (variables, options) {
    return fetchNetlifyGraph({
        query: "mutation CreateGraphQLSchemaMutation($input: OneGraphCreateGraphQLSchemaInput!) {\n  oneGraph {\n    createGraphQLSchema(input: $input) {\n      graphQLSchema {\n        id\n        externalGraphQLSchemas {\n          nodes {\n            id\n            endpoint\n            service\n            createdAt\n            updatedAt\n          }\n        }\n        parentGraphQLSchemaId\n        salesforceSchema {\n          id\n          createdAt\n          updatedAt\n        }\n        services {\n          slug\n        }\n        updatedAt\n        createdAt\n        appId\n      }\n    }\n  }\n}",
        operationName: "CreateGraphQLSchemaMutation",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.executeCreateGraphQLSchemaMutation = executeCreateGraphQLSchemaMutation;
var executeCreatePersistedQueryMutation = function (variables, options) {
    return fetchNetlifyGraph({
        query: "mutation CreatePersistedQueryMutation($nfToken: String!, $cacheStrategy: OneGraphPersistedQueryCacheStrategyArg, $allowedOperationNames: [String!]!, $fallbackOnError: Boolean!, $freeVariables: [String!]!, $query: String!, $tags: [String!]!, $description: String, $appId: String!) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    createPersistedQuery(\n      input: {query: $query, appId: $appId, cacheStrategy: $cacheStrategy, allowedOperationNames: $allowedOperationNames, fallbackOnError: $fallbackOnError, freeVariables: $freeVariables, tags: $tags, description: $description}\n    ) {\n      persistedQuery {\n        id\n        allowedOperationNames\n        description\n        fixedVariables\n        freeVariables\n        query\n        tags\n      }\n    }\n  }\n}",
        operationName: "CreatePersistedQueryMutation",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.executeCreatePersistedQueryMutation = executeCreatePersistedQueryMutation;
var executeCreateApiTokenMutation = function (variables, options) {
    return fetchNetlifyGraph({
        query: "mutation CreateApiTokenMutation($input: OneGraphCreateApiTokenTokenInput!, $nfToken: String!) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    createApiToken(input: $input) {\n      accessToken {\n        token\n        userAuths {\n          service\n          foreignUserId\n          scopes\n        }\n        appId\n        expireDate\n        name\n        netlifyId\n        anchor\n      }\n    }\n  }\n}",
        operationName: "CreateApiTokenMutation",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.executeCreateApiTokenMutation = executeCreateApiTokenMutation;
var fetchListPersistedQueries = function (variables, options) {
    return fetchNetlifyGraph({
        query: "query ListPersistedQueries($appId: String!, $first: Int!, $after: String, $tags: [String!]!) {\n  oneGraph {\n    app(id: $appId) {\n      id\n      persistedQueries(first: $first, after: $after, tags: $tags) {\n        pageInfo {\n          hasNextPage\n          endCursor\n        }\n        nodes {\n          id\n          query\n          fixedVariables\n          freeVariables\n          allowedOperationNames\n          tags\n          description\n        }\n      }\n    }\n  }\n}",
        operationName: "ListPersistedQueries",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.fetchListPersistedQueries = fetchListPersistedQueries;
var fetchPersistedQueryQuery = function (variables, options) {
    return fetchNetlifyGraph({
        query: "query PersistedQueryQuery($nfToken: String!, $appId: String!, $id: String!) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    persistedQuery(appId: $appId, id: $id) {\n      id\n      query\n      allowedOperationNames\n      description\n      freeVariables\n      fixedVariables\n      tags\n    }\n  }\n}",
        operationName: "PersistedQueryQuery",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.fetchPersistedQueryQuery = fetchPersistedQueryQuery;
var executeCreateCLISessionMutation = function (variables, options) {
    return fetchNetlifyGraph({
        query: "mutation CreateCLISessionMutation($nfToken: String!, $appId: String!, $name: String!, $metadata: JSON) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    createNetlifyCliSession(\n      input: {appId: $appId, name: $name, metadata: $metadata}\n    ) {\n      session {\n        id\n        appId\n        netlifyUserId\n        name\n        cliHeartbeatIntervalMs\n      }\n    }\n  }\n}",
        operationName: "CreateCLISessionMutation",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.executeCreateCLISessionMutation = executeCreateCLISessionMutation;
var executeUpdateCLISessionMetadataMutation = function (variables, options) {
    return fetchNetlifyGraph({
        query: "mutation UpdateCLISessionMetadataMutation($nfToken: String!, $sessionId: String!, $metadata: JSON!) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    updateNetlifyCliSession(input: {id: $sessionId, metadata: $metadata}) {\n      session {\n        id\n        name\n        metadata\n        cliHeartbeatIntervalMs\n      }\n    }\n  }\n}",
        operationName: "UpdateCLISessionMetadataMutation",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.executeUpdateCLISessionMetadataMutation = executeUpdateCLISessionMetadataMutation;
var executeCreateCLISessionEventMutation = function (variables, options) {
    return fetchNetlifyGraph({
        query: "mutation CreateCLISessionEventMutation($nfToken: String!, $sessionId: String!, $payload: JSON!) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    createNetlifyCliTestEvent(\n      input: {data: {payload: $payload}, sessionId: $sessionId}\n    ) {\n      event {\n        id\n        createdAt\n        sessionId\n      }\n    }\n  }\n}",
        operationName: "CreateCLISessionEventMutation",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.executeCreateCLISessionEventMutation = executeCreateCLISessionEventMutation;
var fetchCLISessionQuery = function (variables, options) {
    return fetchNetlifyGraph({
        query: "query CLISessionQuery($nfToken: String!, $sessionId: String!, $first: Int!) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    __typename\n    netlifyCliSession(id: $sessionId) {\n      appId\n      createdAt\n      id\n      cliHeartbeatIntervalMs\n      events(first: $first) {\n        __typename\n        createdAt\n        id\n        sessionId\n        ... on OneGraphNetlifyCliSessionLogEvent {\n          id\n          message\n          sessionId\n          createdAt\n        }\n        ... on OneGraphNetlifyCliSessionTestEvent {\n          id\n          createdAt\n          payload\n          sessionId\n        }\n      }\n      lastEventAt\n      metadata\n      name\n      netlifyUserId\n    }\n  }\n}",
        operationName: "CLISessionQuery",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.fetchCLISessionQuery = fetchCLISessionQuery;
var executeAckCLISessionEventMutation = function (variables, options) {
    return fetchNetlifyGraph({
        query: "mutation AckCLISessionEventMutation($nfToken: String!, $sessionId: String!, $eventIds: [String!]!) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    ackNetlifyCliEvents(input: {eventIds: $eventIds, sessionId: $sessionId}) {\n      events {\n        id\n      }\n    }\n  }\n}",
        operationName: "AckCLISessionEventMutation",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.executeAckCLISessionEventMutation = executeAckCLISessionEventMutation;
var fetchAppSchemaQuery = function (variables, options) {
    return fetchNetlifyGraph({
        query: "query AppSchemaQuery($nfToken: String!, $appId: String!) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    app(id: $appId) {\n      graphQLSchema {\n        appId\n        createdAt\n        id\n        services {\n          friendlyServiceName\n          logoUrl\n          service\n          slug\n          supportsCustomRedirectUri\n          supportsCustomServiceAuth\n          supportsOauthLogin\n        }\n        updatedAt\n      }\n    }\n  }\n}",
        operationName: "AppSchemaQuery",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.fetchAppSchemaQuery = fetchAppSchemaQuery;
var executeUpsertAppForSiteMutation = function (variables, options) {
    return fetchNetlifyGraph({
        query: "mutation UpsertAppForSiteMutation($nfToken: String!, $siteId: String!) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    upsertAppForNetlifySite(input: {netlifySiteId: $siteId}) {\n      org {\n        id\n        name\n      }\n      app {\n        id\n        name\n        corsOrigins\n        customCorsOrigins {\n          friendlyServiceName\n          displayName\n          encodedValue\n        }\n      }\n    }\n  }\n}",
        operationName: "UpsertAppForSiteMutation",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.executeUpsertAppForSiteMutation = executeUpsertAppForSiteMutation;
var executeCreateNewSchemaMutation = function (variables, options) {
    return fetchNetlifyGraph({
        query: "mutation CreateNewSchemaMutation($nfToken: String!, $input: OneGraphCreateGraphQLSchemaInput!) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    createGraphQLSchema(input: $input) {\n      app {\n        graphQLSchema {\n          id\n        }\n      }\n      graphqlSchema {\n        id\n        services {\n          friendlyServiceName\n          logoUrl\n          service\n          slug\n          supportsCustomRedirectUri\n          supportsCustomServiceAuth\n          supportsOauthLogin\n        }\n      }\n    }\n  }\n}",
        operationName: "CreateNewSchemaMutation",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.executeCreateNewSchemaMutation = executeCreateNewSchemaMutation;
var executeMarkCLISessionActiveHeartbeat = function (variables, options) {
    return fetchNetlifyGraph({
        query: "mutation MarkCLISessionActiveHeartbeat($nfToken: String!, $id: String!) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    updateNetlifyCliSession(input: {status: ACTIVE, id: $id}) {\n      session {\n        id\n        status\n        createdAt\n        updatedAt\n        cliHeartbeatIntervalMs\n      }\n    }\n  }\n}",
        operationName: "MarkCLISessionActiveHeartbeat",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.executeMarkCLISessionActiveHeartbeat = executeMarkCLISessionActiveHeartbeat;
var executeMarkCLISessionInactive = function (variables, options) {
    return fetchNetlifyGraph({
        query: "mutation MarkCLISessionInactive($nfToken: String!, $id: String!) {\n  oneGraph(auths: {netlifyAuth: {oauthToken: $nfToken}}) {\n    updateNetlifyCliSession(input: {status: INACTIVE, id: $id}) {\n      session {\n        id\n        status\n        createdAt\n        updatedAt\n        cliHeartbeatIntervalMs\n      }\n    }\n  }\n}",
        operationName: "MarkCLISessionInactive",
        variables: variables,
        options: options,
        fetchStrategy: "POST",
    });
};
exports.executeMarkCLISessionInactive = executeMarkCLISessionInactive;
/**
 * The generated NetlifyGraph library with your operations
 */
var functions = {
    /**
     * Create a GraphQL Schema by specifying its inputs (services, external GraphQL schemas, etc.)
     */
    executeCreateGraphQLSchemaMutation: exports.executeCreateGraphQLSchemaMutation,
    /**
     * Create a token belonging to a specific siteId to persist operations and create GraphQL schemas later
     */
    executeCreateApiTokenMutation: exports.executeCreateApiTokenMutation,
    /**
     * Create a persisted operations doc to be later retrieved, usually from a GUI
     */
    executeCreatePersistedQueryMutation: exports.executeCreatePersistedQueryMutation,
    /**
     * Fetch a paginated list of persisted queries belonging to an app
     */
    fetchListPersistedQueries: exports.fetchListPersistedQueries,
    /**
     * Fetch a persisted doc belonging to appId by its id
     */
    fetchPersistedQueryQuery: exports.fetchPersistedQueryQuery,
    /**
     * Register a new CLI session with OneGraph
     */
    executeCreateCLISessionMutation: exports.executeCreateCLISessionMutation,
    /**
     * Update the CLI session with new metadata (e.g. the latest docId) by its id
     */
    executeUpdateCLISessionMetadataMutation: exports.executeUpdateCLISessionMetadataMutation,
    /**
     * Create a new event for a CLI session to consume
     */
    executeCreateCLISessionEventMutation: exports.executeCreateCLISessionEventMutation,
    /**
     * Fetch a single CLI session by its id
     */
    fetchCLISessionQuery: exports.fetchCLISessionQuery,
    /**
     * Acknowledge CLI events that have been processed and delete them from the upstream queue
     */
    executeAckCLISessionEventMutation: exports.executeAckCLISessionEventMutation,
    /**
     * Fetch the schema metadata for a site (enabled services, id, etc.)
     */
    fetchAppSchemaQuery: exports.fetchAppSchemaQuery,
    /**
     * If a site does not exists upstream in OneGraph for the given site, create it
     */
    executeUpsertAppForSiteMutation: exports.executeUpsertAppForSiteMutation,
    /**
     * Create a new schema in OneGraph for the given site with the specified metadata (enabled services, etc.)
     */
    executeCreateNewSchemaMutation: exports.executeCreateNewSchemaMutation,
    /**
     * Mark a CLI session as active and update the session's heartbeat
     */
    executeMarkCLISessionActiveHeartbeat: exports.executeMarkCLISessionActiveHeartbeat,
    /**
     * Mark a CLI session as inactive
     */
    executeMarkCLISessionInactive: exports.executeMarkCLISessionInactive,
};
exports.default = functions;
var handler = function () {
    // return a 401 json response
    return {
        statusCode: 401,
        body: JSON.stringify({
            message: "Unauthorized",
        }),
    };
};
exports.handler = handler;
//# sourceMappingURL=generatedOneGraphClient.js.map